G_BEGIN_DECLS

typedef void (*rtcom_tp_cli_channel_interface_conference_signal_callback_member_channel_added) (TpChannel *proxy,
    const gchar *arg_Channel,
    GHashTable *arg_Handles,
    gpointer user_data, GObject *weak_object);
TpProxySignalConnection *rtcom_tp_cli_channel_interface_conference_connect_to_member_channel_added (TpChannel *proxy,
    rtcom_tp_cli_channel_interface_conference_signal_callback_member_channel_added callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object,
    GError **error);

typedef void (*rtcom_tp_cli_channel_interface_conference_signal_callback_member_channel_removed) (TpChannel *proxy,
    const gchar *arg_Channel,
    guint arg_Actor,
    guint arg_Reason,
    gpointer user_data, GObject *weak_object);
TpProxySignalConnection *rtcom_tp_cli_channel_interface_conference_connect_to_member_channel_removed (TpChannel *proxy,
    rtcom_tp_cli_channel_interface_conference_signal_callback_member_channel_removed callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object,
    GError **error);

typedef void (*rtcom_tp_cli_channel_interface_conference_callback_for_add_member_channels) (TpChannel *proxy,
    const GPtrArray *out_Handles,
    const GError *error, gpointer user_data,
    GObject *weak_object);

TpProxyPendingCall *rtcom_tp_cli_channel_interface_conference_call_add_member_channels (TpChannel *proxy,
    gint timeout_ms,
    const GPtrArray *in_Members,
    rtcom_tp_cli_channel_interface_conference_callback_for_add_member_channels callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object);

gboolean rtcom_tp_cli_channel_interface_conference_run_add_member_channels (TpChannel *proxy,
    gint timeout_ms,
    const GPtrArray *in_Members,
    GPtrArray **out_Handles,
    GError **error,
    GMainLoop **loop);


typedef void (*rtcom_tp_cli_channel_interface_conference_callback_for_get_member_channels) (TpChannel *proxy,
    const GPtrArray *out_Channels,
    const GError *error, gpointer user_data,
    GObject *weak_object);

TpProxyPendingCall *rtcom_tp_cli_channel_interface_conference_call_get_member_channels (TpChannel *proxy,
    gint timeout_ms,
    rtcom_tp_cli_channel_interface_conference_callback_for_get_member_channels callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object);

gboolean rtcom_tp_cli_channel_interface_conference_run_get_member_channels (TpChannel *proxy,
    gint timeout_ms,
    GPtrArray **out_Channels,
    GError **error,
    GMainLoop **loop);


typedef void (*rtcom_tp_cli_channel_interface_conference_member_signal_callback_joined_conference) (TpChannel *proxy,
    const gchar *arg_ConferenceChannel,
    gpointer user_data, GObject *weak_object);
TpProxySignalConnection *rtcom_tp_cli_channel_interface_conference_member_connect_to_joined_conference (TpChannel *proxy,
    rtcom_tp_cli_channel_interface_conference_member_signal_callback_joined_conference callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object,
    GError **error);

typedef void (*rtcom_tp_cli_channel_interface_conference_member_signal_callback_left_conference) (TpChannel *proxy,
    gpointer user_data, GObject *weak_object);
TpProxySignalConnection *rtcom_tp_cli_channel_interface_conference_member_connect_to_left_conference (TpChannel *proxy,
    rtcom_tp_cli_channel_interface_conference_member_signal_callback_left_conference callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object,
    GError **error);

typedef void (*rtcom_tp_cli_channel_interface_conference_member_callback_for_join_conference) (TpChannel *proxy,
    const GError *error, gpointer user_data,
    GObject *weak_object);

TpProxyPendingCall *rtcom_tp_cli_channel_interface_conference_member_call_join_conference (TpChannel *proxy,
    gint timeout_ms,
    const gchar *in_ConferenceChannel,
    rtcom_tp_cli_channel_interface_conference_member_callback_for_join_conference callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object);

gboolean rtcom_tp_cli_channel_interface_conference_member_run_join_conference (TpChannel *proxy,
    gint timeout_ms,
    const gchar *in_ConferenceChannel,
    GError **error,
    GMainLoop **loop);


typedef void (*rtcom_tp_cli_channel_interface_conference_member_callback_for_get_conference) (TpChannel *proxy,
    const gchar *out_ConferenceChannel,
    const GError *error, gpointer user_data,
    GObject *weak_object);

TpProxyPendingCall *rtcom_tp_cli_channel_interface_conference_member_call_get_conference (TpChannel *proxy,
    gint timeout_ms,
    rtcom_tp_cli_channel_interface_conference_member_callback_for_get_conference callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object);

gboolean rtcom_tp_cli_channel_interface_conference_member_run_get_conference (TpChannel *proxy,
    gint timeout_ms,
    gchar **out_ConferenceChannel,
    GError **error,
    GMainLoop **loop);


typedef void (*rtcom_tp_cli_channel_interface_conference_member_callback_for_leave_conference) (TpChannel *proxy,
    const GError *error, gpointer user_data,
    GObject *weak_object);

TpProxyPendingCall *rtcom_tp_cli_channel_interface_conference_member_call_leave_conference (TpChannel *proxy,
    gint timeout_ms,
    rtcom_tp_cli_channel_interface_conference_member_callback_for_leave_conference callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object);

gboolean rtcom_tp_cli_channel_interface_conference_member_run_leave_conference (TpChannel *proxy,
    gint timeout_ms,
    GError **error,
    GMainLoop **loop);


typedef void (*rtcom_tp_cli_channel_interface_dial_strings_signal_callback_sending_dial_string) (TpChannel *proxy,
    guint arg_Stream_ID,
    const gchar *arg_Dial_String,
    gpointer user_data, GObject *weak_object);
TpProxySignalConnection *rtcom_tp_cli_channel_interface_dial_strings_connect_to_sending_dial_string (TpChannel *proxy,
    rtcom_tp_cli_channel_interface_dial_strings_signal_callback_sending_dial_string callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object,
    GError **error);

typedef void (*rtcom_tp_cli_channel_interface_dial_strings_signal_callback_stopped_dial_string) (TpChannel *proxy,
    guint arg_Stream_ID,
    gboolean arg_Sent,
    gpointer user_data, GObject *weak_object);
TpProxySignalConnection *rtcom_tp_cli_channel_interface_dial_strings_connect_to_stopped_dial_string (TpChannel *proxy,
    rtcom_tp_cli_channel_interface_dial_strings_signal_callback_stopped_dial_string callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object,
    GError **error);

typedef void (*rtcom_tp_cli_channel_interface_dial_strings_callback_for_send_dial_string) (TpChannel *proxy,
    const GError *error, gpointer user_data,
    GObject *weak_object);

TpProxyPendingCall *rtcom_tp_cli_channel_interface_dial_strings_call_send_dial_string (TpChannel *proxy,
    gint timeout_ms,
    guint in_Stream_ID,
    const gchar *in_Dial_String,
    guint in_Duration,
    guint in_Pause,
    rtcom_tp_cli_channel_interface_dial_strings_callback_for_send_dial_string callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object);

gboolean rtcom_tp_cli_channel_interface_dial_strings_run_send_dial_string (TpChannel *proxy,
    gint timeout_ms,
    guint in_Stream_ID,
    const gchar *in_Dial_String,
    guint in_Duration,
    guint in_Pause,
    GError **error,
    GMainLoop **loop);


typedef void (*rtcom_tp_cli_channel_interface_dial_strings_callback_for_cancel_dial_string) (TpChannel *proxy,
    const GError *error, gpointer user_data,
    GObject *weak_object);

TpProxyPendingCall *rtcom_tp_cli_channel_interface_dial_strings_call_cancel_dial_string (TpChannel *proxy,
    gint timeout_ms,
    guint in_Stream_ID,
    rtcom_tp_cli_channel_interface_dial_strings_callback_for_cancel_dial_string callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object);

gboolean rtcom_tp_cli_channel_interface_dial_strings_run_cancel_dial_string (TpChannel *proxy,
    gint timeout_ms,
    guint in_Stream_ID,
    GError **error,
    GMainLoop **loop);


typedef void (*rtcom_tp_cli_channel_interface_dial_strings_callback_for_get_current_dial_strings) (TpChannel *proxy,
    GHashTable *out_Dial_Strings,
    const GError *error, gpointer user_data,
    GObject *weak_object);

TpProxyPendingCall *rtcom_tp_cli_channel_interface_dial_strings_call_get_current_dial_strings (TpChannel *proxy,
    gint timeout_ms,
    rtcom_tp_cli_channel_interface_dial_strings_callback_for_get_current_dial_strings callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object);

gboolean rtcom_tp_cli_channel_interface_dial_strings_run_get_current_dial_strings (TpChannel *proxy,
    gint timeout_ms,
    GHashTable **out_Dial_Strings,
    GError **error,
    GMainLoop **loop);


typedef void (*rtcom_tp_cli_channel_interface_emergency_signal_callback_emergency_service_changed) (TpChannel *proxy,
    const gchar *arg_service,
    gpointer user_data, GObject *weak_object);
TpProxySignalConnection *rtcom_tp_cli_channel_interface_emergency_connect_to_emergency_service_changed (TpChannel *proxy,
    rtcom_tp_cli_channel_interface_emergency_signal_callback_emergency_service_changed callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object,
    GError **error);

typedef void (*rtcom_tp_cli_channel_interface_emergency_callback_for_get_emergency_service) (TpChannel *proxy,
    const gchar *out_service,
    const GError *error, gpointer user_data,
    GObject *weak_object);

TpProxyPendingCall *rtcom_tp_cli_channel_interface_emergency_call_get_emergency_service (TpChannel *proxy,
    gint timeout_ms,
    rtcom_tp_cli_channel_interface_emergency_callback_for_get_emergency_service callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object);

gboolean rtcom_tp_cli_channel_interface_emergency_run_get_emergency_service (TpChannel *proxy,
    gint timeout_ms,
    gchar **out_service,
    GError **error,
    GMainLoop **loop);


typedef void (*rtcom_tp_cli_channel_interface_hold_signal_callback_hold_state_changed) (TpChannel *proxy,
    guint arg_HoldState,
    guint arg_Reason,
    gpointer user_data, GObject *weak_object);
TpProxySignalConnection *rtcom_tp_cli_channel_interface_hold_connect_to_hold_state_changed (TpChannel *proxy,
    rtcom_tp_cli_channel_interface_hold_signal_callback_hold_state_changed callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object,
    GError **error);

typedef void (*rtcom_tp_cli_channel_interface_hold_callback_for_get_hold_state) (TpChannel *proxy,
    guint out_HoldState,
    guint out_Reason,
    const GError *error, gpointer user_data,
    GObject *weak_object);

TpProxyPendingCall *rtcom_tp_cli_channel_interface_hold_call_get_hold_state (TpChannel *proxy,
    gint timeout_ms,
    rtcom_tp_cli_channel_interface_hold_callback_for_get_hold_state callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object);

gboolean rtcom_tp_cli_channel_interface_hold_run_get_hold_state (TpChannel *proxy,
    gint timeout_ms,
    guint *out_HoldState,
    guint *out_Reason,
    GError **error,
    GMainLoop **loop);


typedef void (*rtcom_tp_cli_channel_interface_hold_callback_for_request_hold) (TpChannel *proxy,
    const GError *error, gpointer user_data,
    GObject *weak_object);

TpProxyPendingCall *rtcom_tp_cli_channel_interface_hold_call_request_hold (TpChannel *proxy,
    gint timeout_ms,
    gboolean in_Hold,
    rtcom_tp_cli_channel_interface_hold_callback_for_request_hold callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object);

gboolean rtcom_tp_cli_channel_interface_hold_run_request_hold (TpChannel *proxy,
    gint timeout_ms,
    gboolean in_Hold,
    GError **error,
    GMainLoop **loop);


typedef void (*rtcom_tp_cli_channel_interface_messages_signal_callback_message_sent) (TpChannel *proxy,
    const GPtrArray *arg_Content,
    guint arg_Flags,
    const gchar *arg_Message_Token,
    gpointer user_data, GObject *weak_object);
TpProxySignalConnection *rtcom_tp_cli_channel_interface_messages_connect_to_message_sent (TpChannel *proxy,
    rtcom_tp_cli_channel_interface_messages_signal_callback_message_sent callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object,
    GError **error);

typedef void (*rtcom_tp_cli_channel_interface_messages_signal_callback_pending_messages_removed) (TpChannel *proxy,
    const GArray *arg_Message_IDs,
    gpointer user_data, GObject *weak_object);
TpProxySignalConnection *rtcom_tp_cli_channel_interface_messages_connect_to_pending_messages_removed (TpChannel *proxy,
    rtcom_tp_cli_channel_interface_messages_signal_callback_pending_messages_removed callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object,
    GError **error);

typedef void (*rtcom_tp_cli_channel_interface_messages_signal_callback_message_received) (TpChannel *proxy,
    const GPtrArray *arg_Message,
    gpointer user_data, GObject *weak_object);
TpProxySignalConnection *rtcom_tp_cli_channel_interface_messages_connect_to_message_received (TpChannel *proxy,
    rtcom_tp_cli_channel_interface_messages_signal_callback_message_received callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object,
    GError **error);

typedef void (*rtcom_tp_cli_channel_interface_messages_callback_for_send_message) (TpChannel *proxy,
    const gchar *out_Token,
    const GError *error, gpointer user_data,
    GObject *weak_object);

TpProxyPendingCall *rtcom_tp_cli_channel_interface_messages_call_send_message (TpChannel *proxy,
    gint timeout_ms,
    const GPtrArray *in_Message,
    guint in_Flags,
    rtcom_tp_cli_channel_interface_messages_callback_for_send_message callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object);

gboolean rtcom_tp_cli_channel_interface_messages_run_send_message (TpChannel *proxy,
    gint timeout_ms,
    const GPtrArray *in_Message,
    guint in_Flags,
    gchar **out_Token,
    GError **error,
    GMainLoop **loop);


typedef void (*rtcom_tp_cli_channel_interface_messages_callback_for_get_pending_message_content) (TpChannel *proxy,
    GHashTable *out_Content,
    const GError *error, gpointer user_data,
    GObject *weak_object);

TpProxyPendingCall *rtcom_tp_cli_channel_interface_messages_call_get_pending_message_content (TpChannel *proxy,
    gint timeout_ms,
    guint in_Message_ID,
    const GArray *in_Parts,
    rtcom_tp_cli_channel_interface_messages_callback_for_get_pending_message_content callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object);

gboolean rtcom_tp_cli_channel_interface_messages_run_get_pending_message_content (TpChannel *proxy,
    gint timeout_ms,
    guint in_Message_ID,
    const GArray *in_Parts,
    GHashTable **out_Content,
    GError **error,
    GMainLoop **loop);


typedef void (*rtcom_tp_cli_channel_interface_mute_signal_callback_mute_state_changed) (TpChannel *proxy,
    gboolean arg_Muted,
    gpointer user_data, GObject *weak_object);
TpProxySignalConnection *rtcom_tp_cli_channel_interface_mute_connect_to_mute_state_changed (TpChannel *proxy,
    rtcom_tp_cli_channel_interface_mute_signal_callback_mute_state_changed callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object,
    GError **error);

typedef void (*rtcom_tp_cli_channel_interface_mute_callback_for_get_mute_state) (TpChannel *proxy,
    gboolean out_Muted,
    const GError *error, gpointer user_data,
    GObject *weak_object);

TpProxyPendingCall *rtcom_tp_cli_channel_interface_mute_call_get_mute_state (TpChannel *proxy,
    gint timeout_ms,
    rtcom_tp_cli_channel_interface_mute_callback_for_get_mute_state callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object);

gboolean rtcom_tp_cli_channel_interface_mute_run_get_mute_state (TpChannel *proxy,
    gint timeout_ms,
    gboolean *out_Muted,
    GError **error,
    GMainLoop **loop);


typedef void (*rtcom_tp_cli_channel_interface_mute_callback_for_request_mute) (TpChannel *proxy,
    const GError *error, gpointer user_data,
    GObject *weak_object);

TpProxyPendingCall *rtcom_tp_cli_channel_interface_mute_call_request_mute (TpChannel *proxy,
    gint timeout_ms,
    gboolean in_Mute,
    rtcom_tp_cli_channel_interface_mute_callback_for_request_mute callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object);

gboolean rtcom_tp_cli_channel_interface_mute_run_request_mute (TpChannel *proxy,
    gint timeout_ms,
    gboolean in_Mute,
    GError **error,
    GMainLoop **loop);


typedef void (*rtcom_tp_cli_channel_interface_privacy_signal_callback_privacy_services_changed) (TpChannel *proxy,
    const gchar **arg_services,
    gpointer user_data, GObject *weak_object);
TpProxySignalConnection *rtcom_tp_cli_channel_interface_privacy_connect_to_privacy_services_changed (TpChannel *proxy,
    rtcom_tp_cli_channel_interface_privacy_signal_callback_privacy_services_changed callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object,
    GError **error);

typedef void (*rtcom_tp_cli_channel_interface_skype_groupchat_signal_callback_topic_changed) (TpChannel *proxy,
    guint arg_handle,
    const gchar *arg_newtopic,
    gpointer user_data, GObject *weak_object);
TpProxySignalConnection *rtcom_tp_cli_channel_interface_skype_groupchat_connect_to_topic_changed (TpChannel *proxy,
    rtcom_tp_cli_channel_interface_skype_groupchat_signal_callback_topic_changed callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object,
    GError **error);

typedef void (*rtcom_tp_cli_channel_interface_skype_groupchat_callback_for_leave) (TpChannel *proxy,
    const GError *error, gpointer user_data,
    GObject *weak_object);

TpProxyPendingCall *rtcom_tp_cli_channel_interface_skype_groupchat_call_leave (TpChannel *proxy,
    gint timeout_ms,
    rtcom_tp_cli_channel_interface_skype_groupchat_callback_for_leave callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object);

gboolean rtcom_tp_cli_channel_interface_skype_groupchat_run_leave (TpChannel *proxy,
    gint timeout_ms,
    GError **error,
    GMainLoop **loop);


typedef void (*rtcom_tp_cli_channel_type_contact_search_signal_callback_search_state_changed) (TpChannel *proxy,
    guint arg_State,
    const gchar *arg_Error,
    GHashTable *arg_Details,
    gpointer user_data, GObject *weak_object);
TpProxySignalConnection *rtcom_tp_cli_channel_type_contact_search_connect_to_search_state_changed (TpChannel *proxy,
    rtcom_tp_cli_channel_type_contact_search_signal_callback_search_state_changed callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object,
    GError **error);

typedef void (*rtcom_tp_cli_channel_type_contact_search_signal_callback_search_result_received) (TpChannel *proxy,
    guint arg_Contact,
    const GPtrArray *arg_Info,
    gpointer user_data, GObject *weak_object);
TpProxySignalConnection *rtcom_tp_cli_channel_type_contact_search_connect_to_search_result_received (TpChannel *proxy,
    rtcom_tp_cli_channel_type_contact_search_signal_callback_search_result_received callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object,
    GError **error);

typedef void (*rtcom_tp_cli_channel_type_contact_search_callback_for_search) (TpChannel *proxy,
    const GError *error, gpointer user_data,
    GObject *weak_object);

TpProxyPendingCall *rtcom_tp_cli_channel_type_contact_search_call_search (TpChannel *proxy,
    gint timeout_ms,
    GHashTable *in_Terms,
    rtcom_tp_cli_channel_type_contact_search_callback_for_search callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object);

gboolean rtcom_tp_cli_channel_type_contact_search_run_search (TpChannel *proxy,
    gint timeout_ms,
    GHashTable *in_Terms,
    GError **error,
    GMainLoop **loop);


typedef void (*rtcom_tp_cli_channel_type_contact_search_callback_for_more) (TpChannel *proxy,
    const GError *error, gpointer user_data,
    GObject *weak_object);

TpProxyPendingCall *rtcom_tp_cli_channel_type_contact_search_call_more (TpChannel *proxy,
    gint timeout_ms,
    rtcom_tp_cli_channel_type_contact_search_callback_for_more callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object);

gboolean rtcom_tp_cli_channel_type_contact_search_run_more (TpChannel *proxy,
    gint timeout_ms,
    GError **error,
    GMainLoop **loop);


typedef void (*rtcom_tp_cli_channel_type_contact_search_callback_for_stop) (TpChannel *proxy,
    const GError *error, gpointer user_data,
    GObject *weak_object);

TpProxyPendingCall *rtcom_tp_cli_channel_type_contact_search_call_stop (TpChannel *proxy,
    gint timeout_ms,
    rtcom_tp_cli_channel_type_contact_search_callback_for_stop callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object);

gboolean rtcom_tp_cli_channel_type_contact_search_run_stop (TpChannel *proxy,
    gint timeout_ms,
    GError **error,
    GMainLoop **loop);


G_END_DECLS
