#include <glib-object.h>
#include <dbus/dbus-glib.h>
#include <telepathy-glib/dbus-properties-mixin.h>

G_BEGIN_DECLS

/**
 * RTComTpSvcConnectionInterfaceContactInfo:
 *
 * Dummy typedef representing any implementation of this interface.
 */
typedef struct _RTComTpSvcConnectionInterfaceContactInfo RTComTpSvcConnectionInterfaceContactInfo;

/**
 * RTComTpSvcConnectionInterfaceContactInfoClass:
 *
 * The class of RTComTpSvcConnectionInterfaceContactInfo.
 */
typedef struct _RTComTpSvcConnectionInterfaceContactInfoClass RTComTpSvcConnectionInterfaceContactInfoClass;

GType rtcom_tp_svc_connection_interface_contact_info_get_type (void);
#define RTCOM_TYPE_TP_SVC_CONNECTION_INTERFACE_CONTACT_INFO \
  (rtcom_tp_svc_connection_interface_contact_info_get_type ())
#define RTCOM_TP_SVC_CONNECTION_INTERFACE_CONTACT_INFO(obj) \
  (G_TYPE_CHECK_INSTANCE_CAST((obj), RTCOM_TYPE_TP_SVC_CONNECTION_INTERFACE_CONTACT_INFO, RTComTpSvcConnectionInterfaceContactInfo))
#define RTCOM_IS_TP_SVC_CONNECTION_INTERFACE_CONTACT_INFO(obj) \
  (G_TYPE_CHECK_INSTANCE_TYPE((obj), RTCOM_TYPE_TP_SVC_CONNECTION_INTERFACE_CONTACT_INFO))
#define RTCOM_TP_SVC_CONNECTION_INTERFACE_CONTACT_INFO_GET_CLASS(obj) \
  (G_TYPE_INSTANCE_GET_INTERFACE((obj), RTCOM_TYPE_TP_SVC_CONNECTION_INTERFACE_CONTACT_INFO, RTComTpSvcConnectionInterfaceContactInfoClass))


typedef void (*rtcom_tp_svc_connection_interface_contact_info_get_contact_info_impl) (RTComTpSvcConnectionInterfaceContactInfo *self,
    const GArray *in_Contacts,
    DBusGMethodInvocation *context);
void rtcom_tp_svc_connection_interface_contact_info_implement_get_contact_info (RTComTpSvcConnectionInterfaceContactInfoClass *klass, rtcom_tp_svc_connection_interface_contact_info_get_contact_info_impl impl);
/**
 * rtcom_tp_svc_connection_interface_contact_info_return_from_get_contact_info:
 * @context: The D-Bus method invocation context
 * @out_ContactInfo: GHashTable * (FIXME, generate documentation)
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void rtcom_tp_svc_connection_interface_contact_info_return_from_get_contact_info (DBusGMethodInvocation *context,
    GHashTable *out_ContactInfo);
static inline void
rtcom_tp_svc_connection_interface_contact_info_return_from_get_contact_info (DBusGMethodInvocation *context,
    GHashTable *out_ContactInfo)
{
  dbus_g_method_return (context,
      out_ContactInfo);
}

typedef void (*rtcom_tp_svc_connection_interface_contact_info_request_contact_info_impl) (RTComTpSvcConnectionInterfaceContactInfo *self,
    guint in_Contact,
    DBusGMethodInvocation *context);
void rtcom_tp_svc_connection_interface_contact_info_implement_request_contact_info (RTComTpSvcConnectionInterfaceContactInfoClass *klass, rtcom_tp_svc_connection_interface_contact_info_request_contact_info_impl impl);
/**
 * rtcom_tp_svc_connection_interface_contact_info_return_from_request_contact_info:
 * @context: The D-Bus method invocation context
 * @out_Contact_Info: const GPtrArray * (FIXME, generate documentation)
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void rtcom_tp_svc_connection_interface_contact_info_return_from_request_contact_info (DBusGMethodInvocation *context,
    const GPtrArray *out_Contact_Info);
static inline void
rtcom_tp_svc_connection_interface_contact_info_return_from_request_contact_info (DBusGMethodInvocation *context,
    const GPtrArray *out_Contact_Info)
{
  dbus_g_method_return (context,
      out_Contact_Info);
}

typedef void (*rtcom_tp_svc_connection_interface_contact_info_set_contact_info_impl) (RTComTpSvcConnectionInterfaceContactInfo *self,
    const GPtrArray *in_ContactInfo,
    DBusGMethodInvocation *context);
void rtcom_tp_svc_connection_interface_contact_info_implement_set_contact_info (RTComTpSvcConnectionInterfaceContactInfoClass *klass, rtcom_tp_svc_connection_interface_contact_info_set_contact_info_impl impl);
/**
 * rtcom_tp_svc_connection_interface_contact_info_return_from_set_contact_info:
 * @context: The D-Bus method invocation context
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void rtcom_tp_svc_connection_interface_contact_info_return_from_set_contact_info (DBusGMethodInvocation *context);
static inline void
rtcom_tp_svc_connection_interface_contact_info_return_from_set_contact_info (DBusGMethodInvocation *context)
{
  dbus_g_method_return (context);
}

void rtcom_tp_svc_connection_interface_contact_info_emit_contactinfochanged (gpointer instance,
    guint arg_Contact,
    const GPtrArray *arg_ContactInfo);

/**
 * RTComTpSvcConnectionInterfaceEmergency:
 *
 * Dummy typedef representing any implementation of this interface.
 */
typedef struct _RTComTpSvcConnectionInterfaceEmergency RTComTpSvcConnectionInterfaceEmergency;

/**
 * RTComTpSvcConnectionInterfaceEmergencyClass:
 *
 * The class of RTComTpSvcConnectionInterfaceEmergency.
 */
typedef struct _RTComTpSvcConnectionInterfaceEmergencyClass RTComTpSvcConnectionInterfaceEmergencyClass;

GType rtcom_tp_svc_connection_interface_emergency_get_type (void);
#define RTCOM_TYPE_TP_SVC_CONNECTION_INTERFACE_EMERGENCY \
  (rtcom_tp_svc_connection_interface_emergency_get_type ())
#define RTCOM_TP_SVC_CONNECTION_INTERFACE_EMERGENCY(obj) \
  (G_TYPE_CHECK_INSTANCE_CAST((obj), RTCOM_TYPE_TP_SVC_CONNECTION_INTERFACE_EMERGENCY, RTComTpSvcConnectionInterfaceEmergency))
#define RTCOM_IS_TP_SVC_CONNECTION_INTERFACE_EMERGENCY(obj) \
  (G_TYPE_CHECK_INSTANCE_TYPE((obj), RTCOM_TYPE_TP_SVC_CONNECTION_INTERFACE_EMERGENCY))
#define RTCOM_TP_SVC_CONNECTION_INTERFACE_EMERGENCY_GET_CLASS(obj) \
  (G_TYPE_INSTANCE_GET_INTERFACE((obj), RTCOM_TYPE_TP_SVC_CONNECTION_INTERFACE_EMERGENCY, RTComTpSvcConnectionInterfaceEmergencyClass))


typedef void (*rtcom_tp_svc_connection_interface_emergency_get_emergency_services_impl) (RTComTpSvcConnectionInterfaceEmergency *self,
    DBusGMethodInvocation *context);
void rtcom_tp_svc_connection_interface_emergency_implement_get_emergency_services (RTComTpSvcConnectionInterfaceEmergencyClass *klass, rtcom_tp_svc_connection_interface_emergency_get_emergency_services_impl impl);
/**
 * rtcom_tp_svc_connection_interface_emergency_return_from_get_emergency_services:
 * @context: The D-Bus method invocation context
 * @out_services: const GPtrArray * (FIXME, generate documentation)
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void rtcom_tp_svc_connection_interface_emergency_return_from_get_emergency_services (DBusGMethodInvocation *context,
    const GPtrArray *out_services);
static inline void
rtcom_tp_svc_connection_interface_emergency_return_from_get_emergency_services (DBusGMethodInvocation *context,
    const GPtrArray *out_services)
{
  dbus_g_method_return (context,
      out_services);
}

void rtcom_tp_svc_connection_interface_emergency_emit_emergency_services_changed (gpointer instance,
    const GPtrArray *arg_services);

/**
 * RTComTpSvcConnectionInterfaceForwarding:
 *
 * Dummy typedef representing any implementation of this interface.
 */
typedef struct _RTComTpSvcConnectionInterfaceForwarding RTComTpSvcConnectionInterfaceForwarding;

/**
 * RTComTpSvcConnectionInterfaceForwardingClass:
 *
 * The class of RTComTpSvcConnectionInterfaceForwarding.
 */
typedef struct _RTComTpSvcConnectionInterfaceForwardingClass RTComTpSvcConnectionInterfaceForwardingClass;

GType rtcom_tp_svc_connection_interface_forwarding_get_type (void);
#define RTCOM_TYPE_TP_SVC_CONNECTION_INTERFACE_FORWARDING \
  (rtcom_tp_svc_connection_interface_forwarding_get_type ())
#define RTCOM_TP_SVC_CONNECTION_INTERFACE_FORWARDING(obj) \
  (G_TYPE_CHECK_INSTANCE_CAST((obj), RTCOM_TYPE_TP_SVC_CONNECTION_INTERFACE_FORWARDING, RTComTpSvcConnectionInterfaceForwarding))
#define RTCOM_IS_TP_SVC_CONNECTION_INTERFACE_FORWARDING(obj) \
  (G_TYPE_CHECK_INSTANCE_TYPE((obj), RTCOM_TYPE_TP_SVC_CONNECTION_INTERFACE_FORWARDING))
#define RTCOM_TP_SVC_CONNECTION_INTERFACE_FORWARDING_GET_CLASS(obj) \
  (G_TYPE_INSTANCE_GET_INTERFACE((obj), RTCOM_TYPE_TP_SVC_CONNECTION_INTERFACE_FORWARDING, RTComTpSvcConnectionInterfaceForwardingClass))


typedef void (*rtcom_tp_svc_connection_interface_forwarding_get_forwarding_handle_impl) (RTComTpSvcConnectionInterfaceForwarding *self,
    DBusGMethodInvocation *context);
void rtcom_tp_svc_connection_interface_forwarding_implement_get_forwarding_handle (RTComTpSvcConnectionInterfaceForwardingClass *klass, rtcom_tp_svc_connection_interface_forwarding_get_forwarding_handle_impl impl);
/**
 * rtcom_tp_svc_connection_interface_forwarding_return_from_get_forwarding_handle:
 * @context: The D-Bus method invocation context
 * @out0: guint  (FIXME, generate documentation)
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void rtcom_tp_svc_connection_interface_forwarding_return_from_get_forwarding_handle (DBusGMethodInvocation *context,
    guint out0);
static inline void
rtcom_tp_svc_connection_interface_forwarding_return_from_get_forwarding_handle (DBusGMethodInvocation *context,
    guint out0)
{
  dbus_g_method_return (context,
      out0);
}

typedef void (*rtcom_tp_svc_connection_interface_forwarding_set_forwarding_handle_impl) (RTComTpSvcConnectionInterfaceForwarding *self,
    guint in_forward_to,
    DBusGMethodInvocation *context);
void rtcom_tp_svc_connection_interface_forwarding_implement_set_forwarding_handle (RTComTpSvcConnectionInterfaceForwardingClass *klass, rtcom_tp_svc_connection_interface_forwarding_set_forwarding_handle_impl impl);
/**
 * rtcom_tp_svc_connection_interface_forwarding_return_from_set_forwarding_handle:
 * @context: The D-Bus method invocation context
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void rtcom_tp_svc_connection_interface_forwarding_return_from_set_forwarding_handle (DBusGMethodInvocation *context);
static inline void
rtcom_tp_svc_connection_interface_forwarding_return_from_set_forwarding_handle (DBusGMethodInvocation *context)
{
  dbus_g_method_return (context);
}

void rtcom_tp_svc_connection_interface_forwarding_emit_forwarding_changed (gpointer instance,
    guint arg_forward_to);

/**
 * RTComTpSvcConnectionInterfaceGSM:
 *
 * Dummy typedef representing any implementation of this interface.
 */
typedef struct _RTComTpSvcConnectionInterfaceGSM RTComTpSvcConnectionInterfaceGSM;

/**
 * RTComTpSvcConnectionInterfaceGSMClass:
 *
 * The class of RTComTpSvcConnectionInterfaceGSM.
 */
typedef struct _RTComTpSvcConnectionInterfaceGSMClass RTComTpSvcConnectionInterfaceGSMClass;

GType rtcom_tp_svc_connection_interface_gsm_get_type (void);
#define RTCOM_TYPE_TP_SVC_CONNECTION_INTERFACE_GSM \
  (rtcom_tp_svc_connection_interface_gsm_get_type ())
#define RTCOM_TP_SVC_CONNECTION_INTERFACE_GSM(obj) \
  (G_TYPE_CHECK_INSTANCE_CAST((obj), RTCOM_TYPE_TP_SVC_CONNECTION_INTERFACE_GSM, RTComTpSvcConnectionInterfaceGSM))
#define RTCOM_IS_TP_SVC_CONNECTION_INTERFACE_GSM(obj) \
  (G_TYPE_CHECK_INSTANCE_TYPE((obj), RTCOM_TYPE_TP_SVC_CONNECTION_INTERFACE_GSM))
#define RTCOM_TP_SVC_CONNECTION_INTERFACE_GSM_GET_CLASS(obj) \
  (G_TYPE_INSTANCE_GET_INTERFACE((obj), RTCOM_TYPE_TP_SVC_CONNECTION_INTERFACE_GSM, RTComTpSvcConnectionInterfaceGSMClass))



/**
 * RTComTpSvcConnectionInterfacePrivacy:
 *
 * Dummy typedef representing any implementation of this interface.
 */
typedef struct _RTComTpSvcConnectionInterfacePrivacy RTComTpSvcConnectionInterfacePrivacy;

/**
 * RTComTpSvcConnectionInterfacePrivacyClass:
 *
 * The class of RTComTpSvcConnectionInterfacePrivacy.
 */
typedef struct _RTComTpSvcConnectionInterfacePrivacyClass RTComTpSvcConnectionInterfacePrivacyClass;

GType rtcom_tp_svc_connection_interface_privacy_get_type (void);
#define RTCOM_TYPE_TP_SVC_CONNECTION_INTERFACE_PRIVACY \
  (rtcom_tp_svc_connection_interface_privacy_get_type ())
#define RTCOM_TP_SVC_CONNECTION_INTERFACE_PRIVACY(obj) \
  (G_TYPE_CHECK_INSTANCE_CAST((obj), RTCOM_TYPE_TP_SVC_CONNECTION_INTERFACE_PRIVACY, RTComTpSvcConnectionInterfacePrivacy))
#define RTCOM_IS_TP_SVC_CONNECTION_INTERFACE_PRIVACY(obj) \
  (G_TYPE_CHECK_INSTANCE_TYPE((obj), RTCOM_TYPE_TP_SVC_CONNECTION_INTERFACE_PRIVACY))
#define RTCOM_TP_SVC_CONNECTION_INTERFACE_PRIVACY_GET_CLASS(obj) \
  (G_TYPE_INSTANCE_GET_INTERFACE((obj), RTCOM_TYPE_TP_SVC_CONNECTION_INTERFACE_PRIVACY, RTComTpSvcConnectionInterfacePrivacyClass))


void rtcom_tp_svc_connection_interface_privacy_emit_privacy_services_changed (gpointer instance,
    const gchar **arg_services);

/**
 * RTComTpSvcConnectionInterfaceSkypeCreditInfo:
 *
 * Dummy typedef representing any implementation of this interface.
 */
typedef struct _RTComTpSvcConnectionInterfaceSkypeCreditInfo RTComTpSvcConnectionInterfaceSkypeCreditInfo;

/**
 * RTComTpSvcConnectionInterfaceSkypeCreditInfoClass:
 *
 * The class of RTComTpSvcConnectionInterfaceSkypeCreditInfo.
 */
typedef struct _RTComTpSvcConnectionInterfaceSkypeCreditInfoClass RTComTpSvcConnectionInterfaceSkypeCreditInfoClass;

GType rtcom_tp_svc_connection_interface_skype_creditinfo_get_type (void);
#define RTCOM_TYPE_TP_SVC_CONNECTION_INTERFACE_SKYPE_CREDITINFO \
  (rtcom_tp_svc_connection_interface_skype_creditinfo_get_type ())
#define RTCOM_TP_SVC_CONNECTION_INTERFACE_SKYPE_CREDITINFO(obj) \
  (G_TYPE_CHECK_INSTANCE_CAST((obj), RTCOM_TYPE_TP_SVC_CONNECTION_INTERFACE_SKYPE_CREDITINFO, RTComTpSvcConnectionInterfaceSkypeCreditInfo))
#define RTCOM_IS_TP_SVC_CONNECTION_INTERFACE_SKYPE_CREDITINFO(obj) \
  (G_TYPE_CHECK_INSTANCE_TYPE((obj), RTCOM_TYPE_TP_SVC_CONNECTION_INTERFACE_SKYPE_CREDITINFO))
#define RTCOM_TP_SVC_CONNECTION_INTERFACE_SKYPE_CREDITINFO_GET_CLASS(obj) \
  (G_TYPE_INSTANCE_GET_INTERFACE((obj), RTCOM_TYPE_TP_SVC_CONNECTION_INTERFACE_SKYPE_CREDITINFO, RTComTpSvcConnectionInterfaceSkypeCreditInfoClass))


void rtcom_tp_svc_connection_interface_skype_creditinfo_emit_balance_changed (gpointer instance,
    guint arg_Balance,
    guint arg_BalanceScale,
    const gchar *arg_Currency);

/**
 * RTComTpSvcConnectionInterfaceStoredMessages:
 *
 * Dummy typedef representing any implementation of this interface.
 */
typedef struct _RTComTpSvcConnectionInterfaceStoredMessages RTComTpSvcConnectionInterfaceStoredMessages;

/**
 * RTComTpSvcConnectionInterfaceStoredMessagesClass:
 *
 * The class of RTComTpSvcConnectionInterfaceStoredMessages.
 */
typedef struct _RTComTpSvcConnectionInterfaceStoredMessagesClass RTComTpSvcConnectionInterfaceStoredMessagesClass;

GType rtcom_tp_svc_connection_interface_stored_messages_get_type (void);
#define RTCOM_TYPE_TP_SVC_CONNECTION_INTERFACE_STORED_MESSAGES \
  (rtcom_tp_svc_connection_interface_stored_messages_get_type ())
#define RTCOM_TP_SVC_CONNECTION_INTERFACE_STORED_MESSAGES(obj) \
  (G_TYPE_CHECK_INSTANCE_CAST((obj), RTCOM_TYPE_TP_SVC_CONNECTION_INTERFACE_STORED_MESSAGES, RTComTpSvcConnectionInterfaceStoredMessages))
#define RTCOM_IS_TP_SVC_CONNECTION_INTERFACE_STORED_MESSAGES(obj) \
  (G_TYPE_CHECK_INSTANCE_TYPE((obj), RTCOM_TYPE_TP_SVC_CONNECTION_INTERFACE_STORED_MESSAGES))
#define RTCOM_TP_SVC_CONNECTION_INTERFACE_STORED_MESSAGES_GET_CLASS(obj) \
  (G_TYPE_INSTANCE_GET_INTERFACE((obj), RTCOM_TYPE_TP_SVC_CONNECTION_INTERFACE_STORED_MESSAGES, RTComTpSvcConnectionInterfaceStoredMessagesClass))


typedef void (*rtcom_tp_svc_connection_interface_stored_messages_deliver_stored_messages_impl) (RTComTpSvcConnectionInterfaceStoredMessages *self,
    const gchar **in_StoredMessageTokens,
    DBusGMethodInvocation *context);
void rtcom_tp_svc_connection_interface_stored_messages_implement_deliver_stored_messages (RTComTpSvcConnectionInterfaceStoredMessagesClass *klass, rtcom_tp_svc_connection_interface_stored_messages_deliver_stored_messages_impl impl);
/**
 * rtcom_tp_svc_connection_interface_stored_messages_return_from_deliver_stored_messages:
 * @context: The D-Bus method invocation context
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void rtcom_tp_svc_connection_interface_stored_messages_return_from_deliver_stored_messages (DBusGMethodInvocation *context);
static inline void
rtcom_tp_svc_connection_interface_stored_messages_return_from_deliver_stored_messages (DBusGMethodInvocation *context)
{
  dbus_g_method_return (context);
}

typedef void (*rtcom_tp_svc_connection_interface_stored_messages_expunge_messages_impl) (RTComTpSvcConnectionInterfaceStoredMessages *self,
    const gchar **in_StoredMessageTokens,
    DBusGMethodInvocation *context);
void rtcom_tp_svc_connection_interface_stored_messages_implement_expunge_messages (RTComTpSvcConnectionInterfaceStoredMessagesClass *klass, rtcom_tp_svc_connection_interface_stored_messages_expunge_messages_impl impl);
/**
 * rtcom_tp_svc_connection_interface_stored_messages_return_from_expunge_messages:
 * @context: The D-Bus method invocation context
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void rtcom_tp_svc_connection_interface_stored_messages_return_from_expunge_messages (DBusGMethodInvocation *context);
static inline void
rtcom_tp_svc_connection_interface_stored_messages_return_from_expunge_messages (DBusGMethodInvocation *context)
{
  dbus_g_method_return (context);
}

typedef void (*rtcom_tp_svc_connection_interface_stored_messages_set_storage_state_impl) (RTComTpSvcConnectionInterfaceStoredMessages *self,
    gboolean in_OutOfStorage,
    DBusGMethodInvocation *context);
void rtcom_tp_svc_connection_interface_stored_messages_implement_set_storage_state (RTComTpSvcConnectionInterfaceStoredMessagesClass *klass, rtcom_tp_svc_connection_interface_stored_messages_set_storage_state_impl impl);
/**
 * rtcom_tp_svc_connection_interface_stored_messages_return_from_set_storage_state:
 * @context: The D-Bus method invocation context
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void rtcom_tp_svc_connection_interface_stored_messages_return_from_set_storage_state (DBusGMethodInvocation *context);
static inline void
rtcom_tp_svc_connection_interface_stored_messages_return_from_set_storage_state (DBusGMethodInvocation *context)
{
  dbus_g_method_return (context);
}

void rtcom_tp_svc_connection_interface_stored_messages_emit_messages_expunged (gpointer instance,
    const gchar **arg_Stored_Message_Tokens);


G_END_DECLS
